aboutsummaryrefslogtreecommitdiff
path: root/v2/src/bin/category
diff options
context:
space:
mode:
Diffstat (limited to 'v2/src/bin/category')
-rwxr-xr-xv2/src/bin/category80
1 files changed, 80 insertions, 0 deletions
diff --git a/v2/src/bin/category b/v2/src/bin/category
new file mode 100755
index 0000000..2a2fdea
--- /dev/null
+++ b/v2/src/bin/category
@@ -0,0 +1,80 @@
+#!/bin/sh
+set -eu
+
+usage() {
+ cat <<-'EOF'
+ Usage:
+ category FILENAME
+ html -h
+ EOF
+}
+
+help() {
+ cat <<-'EOF'
+
+
+ Options:
+ -h, --help show this message
+
+ FILENAME the name of the input file .md file
+
+
+ Process the FILENAME, and generate a the derived category files.
+
+
+ Examples:
+
+ Generate the categories for a pastebin:
+
+ $ categories src/a-paste.md > src/a-paste.categoryentry
+ EOF
+}
+
+
+for f in "$@"; do
+ case "$f" in
+ --)
+ break
+ ;;
+ --help)
+ usage
+ help
+ exit
+ ;;
+ *)
+ ;;
+ esac
+done
+
+while getopts 'h' flag; do
+ case "$flag" in
+ h)
+ usage
+ help
+ exit
+ ;;
+ *)
+ usage >&2
+ exit 2
+ ;;
+ esac
+done
+shift $((OPTIND - 1))
+
+. src/lib.sh
+
+FILENAME="${1:-}"
+eval "$(assert_arg "$FILENAME" 'FILENAME')"
+
+
+# shellcheck source=/dev/null
+. "${FILENAME%.md}.conf"
+DIR="$(dirname "$FILENAME")"
+
+
+
+echo "${categories:-}" | tr ' ' '\n' | grep . | while read -r category; do
+ echo "$FILENAME" > "$DIR/${date_iso:?}.$category.categorysort"
+done
+
+envsubst < src/lib/category.html